//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private NPCPHTChopFree[] cacheNPCPHTChopFree = null;

        private static NPCPHTChopFree checkNPCPHTChopFree = new NPCPHTChopFree();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NPCPHTChopFree NPCPHTChopFree(string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            return NPCPHTChopFree(Input, i00_Version020515, i91_UpColor, i92_DownColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NPCPHTChopFree NPCPHTChopFree(Data.IDataSeries input, string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            if (cacheNPCPHTChopFree != null)
                for (int idx = 0; idx < cacheNPCPHTChopFree.Length; idx++)
                    if (cacheNPCPHTChopFree[idx].I00_Version020515 == i00_Version020515 && cacheNPCPHTChopFree[idx].I91_UpColor == i91_UpColor && cacheNPCPHTChopFree[idx].I92_DownColor == i92_DownColor && cacheNPCPHTChopFree[idx].EqualsInput(input))
                        return cacheNPCPHTChopFree[idx];

            lock (checkNPCPHTChopFree)
            {
                checkNPCPHTChopFree.I00_Version020515 = i00_Version020515;
                i00_Version020515 = checkNPCPHTChopFree.I00_Version020515;
                checkNPCPHTChopFree.I91_UpColor = i91_UpColor;
                i91_UpColor = checkNPCPHTChopFree.I91_UpColor;
                checkNPCPHTChopFree.I92_DownColor = i92_DownColor;
                i92_DownColor = checkNPCPHTChopFree.I92_DownColor;

                if (cacheNPCPHTChopFree != null)
                    for (int idx = 0; idx < cacheNPCPHTChopFree.Length; idx++)
                        if (cacheNPCPHTChopFree[idx].I00_Version020515 == i00_Version020515 && cacheNPCPHTChopFree[idx].I91_UpColor == i91_UpColor && cacheNPCPHTChopFree[idx].I92_DownColor == i92_DownColor && cacheNPCPHTChopFree[idx].EqualsInput(input))
                            return cacheNPCPHTChopFree[idx];

                NPCPHTChopFree indicator = new NPCPHTChopFree();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.I00_Version020515 = i00_Version020515;
                indicator.I91_UpColor = i91_UpColor;
                indicator.I92_DownColor = i92_DownColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NPCPHTChopFree[] tmp = new NPCPHTChopFree[cacheNPCPHTChopFree == null ? 1 : cacheNPCPHTChopFree.Length + 1];
                if (cacheNPCPHTChopFree != null)
                    cacheNPCPHTChopFree.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNPCPHTChopFree = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NPCPHTChopFree NPCPHTChopFree(string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            return _indicator.NPCPHTChopFree(Input, i00_Version020515, i91_UpColor, i92_DownColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NPCPHTChopFree NPCPHTChopFree(Data.IDataSeries input, string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            return _indicator.NPCPHTChopFree(input, i00_Version020515, i91_UpColor, i92_DownColor);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NPCPHTChopFree NPCPHTChopFree(string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            return _indicator.NPCPHTChopFree(Input, i00_Version020515, i91_UpColor, i92_DownColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NPCPHTChopFree NPCPHTChopFree(Data.IDataSeries input, string i00_Version020515, Color i91_UpColor, Color i92_DownColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NPCPHTChopFree(input, i00_Version020515, i91_UpColor, i92_DownColor);
        }
    }
}
#endregion
